package animation;

/**
 * An action some kind of command that can be send to the {@link AnimatedAlgorithm} from the {@link AnimationController}.
 * {@code FORWARD} tells the {@link AnimatedAlgorithm} to perform one more step in the layout process.
 * {@code BACKWARD} tells the {@link AnimatedAlgorithm} to undo the last step in the layout process.
 * 
 * @author kolja
 *
 */
public enum Action {
    FORWARD,
    FORWARD_OVER,
    FORWARD_OUT,
    BACKWARD,
    BACKWARD_OVER,
    BACKWARD_OUT
}
